﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Newtonsoft.Json;

namespace Gw2Api
{
    class WorldNames
    {
        public string id;
        public string name;
    }

    public class WorldNameApi : BaseApi
    {
        List<WorldNames> _worldNames;

        public WorldNameApi()
        {
            LoadWorldNameApi();
        }

        public string GetWorldFromId(string id)
        {
            var world = _worldNames.FirstOrDefault(wn => wn.id == id);
            if (world != null)
            {
                return world.name;
            }
            return "";
        }

        public string GetWorldIdFromName(string name)
        {
            return _worldNames.Where(wn => wn.name == name).First().id;
        }

        public IEnumerable<string> GetWorldNames()
        {
            return _worldNames.Where(wn => wn.name != null).Select(wn => wn.name).OrderBy(s => s);
        }

        private void EnsureLoaded()
        {
        }

        private void LoadWorldNameApi()
        {
            string s = LoadFromUrl(ApiUrls.WorldNames);
            _worldNames = JsonConvert.DeserializeObject<List<WorldNames>>(s);
        }
    }
}
