﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;

namespace Gw2WvWMapControl
{
    public class ObjectiveDisplayConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (null == value)
                return "";
            return ObjectiveDisplayToText(value as WvWObjectiveDisplay);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        private string ObjectiveDisplayToText(WvWObjectiveDisplay obj)
        {
            TimeSpan time = (new TimeSpan(0, 5, 0) - (DateTime.UtcNow - obj.ts));
            return obj.name + "(" + obj.owner + ")"
                + (obj.owner_guild != null && obj.owner_guild.Length > 0 ? "\nClaimed by guild" : "" )
                + (time.TotalSeconds >= 0 ? "\nRI ends in " + time.ToString(@"mm\:ss") : "");
        }
    }
}
